//customSounds.cs	For engine sounds and any sound not native to BL
//otherSounds.cs	Regular sounds of a vehicle
//server.cs		Vehicle settings, speedcheck
//Support_objects.cs	Things relating to modifying of the actual train(audio+horn+moving)

exec("./customSounds.cs");

exec("./otherDB.cs");

//----------------------------------------------------------------------------

datablock WheeledVehicleData(LegoFreightvehicle)
{
    category = "Vehicles";
    displayName = " ";
    shapeFile = "./shapes/LegoFreight.dts";
    emap = true;
    minMountDist = 3;
   
    numMountPoints = 5;
    mountThread[0] = "sit";
	mountThread[1] = "root";
	mountThread[2] = "root";
	mountThread[3] = "root";
	mountThread[4] = "root";

    maxDamage = 200.00;
    destroyedLevel = 200.00;
    energyPerDamagePoint = 160;
    speedDamageScale = 1.04;
    collDamageThresholdVel = 20.0;
    collDamageMultiplier   = 0.02;

    massCenter = "0 0 0";
    //massBox = "2 5 1";

    maxSteeringAngle = 0;  // Maximum steering angle, should match animation
    integration = 4;           // Force integration time: TickSec/Rate
    //tireEmitter = TireEmitter; // All the tires use the same dust emitter

    // 3rd person camera settings
    cameraRoll = false;         // Roll the camera with the vehicle
    cameraMaxDist = 30;         // Far distance from vehicle
    cameraOffset = 20;        // Vertical offset from camera mount point
    cameraLag = 0.0;           // Velocity lag of camera
    cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
    cameraTilt = 0.75;
    collisionTol = 0.1;        // Collision distance tolerance
    contactTol = 0.1;

    useEyePoint = false;    

	defaultTire	= tankTire;
	defaultSpring	= tankSpring;

    numWheels = 4;

    // Rigid Body
    mass = 300;
    density = 5.0;
    drag = 1.6;
    bodyFriction = 0.6;
    bodyRestitution = 0.6;
    minImpactSpeed = 10;       // Impacts over this invoke the script callback
    softImpactSpeed = 10;      // Play SoftImpact Sound
    hardImpactSpeed = 15;      // Play HardImpact Sound
    groundImpactMinSpeed    = 10.0;

    // Engine
    engineTorque = 300;      // Engine power
    engineBrake = 100;        // Braking when throttle is 0
    brakeTorque = 650;        // When brakes are applied
    maxWheelSpeed = 100;       // Engine scale by current speed / max speed

    rollForce        = 0;
    yawForce        = 0;
    pitchForce        = 1000;
    rotationalDrag        = 0.2;

    // Energy
    maxEnergy = 100;
    jetForce = 3000;
    minJetEnergy = 30;
    jetEnergyDrain = 2;

    splash = vehicleSplash;
    splashVelocity = 4.0;
    splashAngle = 67.0;
    splashFreqMod = 300.0;
    splashVelEpsilon = 0.60;
    bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
    mediumSplashSoundVelocity = 10.0;   
    hardSplashSoundVelocity = 20.0;   
    exitSplashSoundVelocity = 5.0;
        
    //mediumSplashSound = "";
    //hardSplashSound = "";
    //exitSplashSound = "";
    
    // Sounds
    //jetSound = ScoutThrustSound;
    //engineSound = idleSound;
    squealSound = squealSound;
    softImpactSound = slowImpactSound;
    hardImpactSound = fastImpactSound;
    //wheelImpactSound = slowImpactSound;

    //explosion = VehicleExplosion;
    justcollided = 0;

    uiName = "Lego Freight Train";
    rideable = true;
    lookUpLimit = 0.65;
    lookDownLimit = 0.45;

    paintable = true;
   
    damageEmitter[0] = VehicleBurnEmitter;
    damageEmitterOffset[0] = "0.0 0.0 0.0 ";
    damageLevelTolerance[0] = 0.99;

    damageEmitter[1] = VehicleBurnEmitter;
    damageEmitterOffset[1] = "0.0 0.0 0.0 ";
    damageLevelTolerance[1] = 1.0;

    numDmgEmitterAreas = 1;

    initialExplosionProjectile = jeepExplosionProjectile;
    initialExplosionOffset = 0;         //offset only uses a z value for now

    burnTime = 4000;

    finalExplosionProjectile = jeepFinalExplosionProjectile;
    finalExplosionOffset = 0.5;          //offset only uses a z value for now


    minRunOverSpeed    = 0.1;   //how fast you need to be going to run someone over (do damage)
    runOverDamageScale = 20;     //when you run over someone, speed * runoverdamagescale = damage amt
    runOverPushScale   = 20;   //how hard a person you're running over gets pushed
};

function LegoFreightvehicleSpeedCheck(%this, %obj)
{

	if(!isObject(%obj))
		return;

	%vehicle = %obj;


	%slot = 0; //Play the sound in the driver's spot
	%speed = vectorLen(%obj.getVelocity());
	if(!%vehicle.oldSpeed)
	    %vehicle.oldSpeed = %speed;

	//Braking is not working currently
	if(%vehicle.oldSpeed)
	{
		if((%vehicle.oldSpeed - %speed) > 1) //Braking rate of speed in 500MS
			%applyBrakes = true;

		if((%vehicle.oldSpeed - %speed) < 1)
			%applyBrakes = false;
	}

	if(%speed < 0) //Keeps throwing random negative numbers when train is at dead stop
	    %speed = 0;

	%vehicle.oldSpeed = %speed;
	commandtoclient(%vehicle.getControllingClient(),'bottomprint', mFloor(%speed * 2) @"<font:impact:25><color:FFFFFF> BPS", 1);

	//We use else if's so that it will find a true statement then skip the rest
	if(%speed < 2) {
	    %vehicle.stopAudio(%slot);
	    }

	else if(%speed < 10)
	    %vehicle.playAudio(%slot, throttle0Sound);

	else if(%speed < 15)
	    %vehicle.playAudio(%slot, throttle1Sound);

	else if(%speed < 30)
	    %vehicle.playAudio(%slot, throttle2Sound);

	else if(%speed < 45)
	    %vehicle.playAudio(%slot, throttle3Sound);

	else if(%speed < 60)
	    %vehicle.playAudio(%slot, throttle4Sound);

	else if(%speed < 80)
	    %vehicle.playAudio(%slot, throttle5Sound);

	else if(%speed < 90)
	    %vehicle.playAudio(%slot, throttle6Sound);



	if(%applyBrakes)
		%vehicle.playAudio(1, squealSound);
	if(!%applyBrakes)
		%vehicle.stopAudio(1);
	    

	schedule(500,0,"LegoFreightvehicleSpeedCheck",%this,%obj);
}

function LegoFreightvehicle::onadd(%this, %obj)
{

	parent::onadd(%this,%obj);
	//Switched to first position so the vehicle is created before it's checked on

	LegoFreightvehicleSpeedCheck(%this, %obj);
	//Traintire.radius=0.65;	// Messes others players
	//Trainbacktire.radius=0.55;	// up so they are glitchy
}

exec("./Support_objects.cs");
